Index: /boa/src/main/java/geniusweb/boa/BoaParty.java
===================================================================
--- /boa/src/main/java/geniusweb/boa/BoaParty.java	(revision 20)
+++ /boa/src/main/java/geniusweb/boa/BoaParty.java	(revision 21)
@@ -6,6 +6,6 @@
 import geniusweb.boa.acceptancestrategy.AcceptanceStrategy;
 import geniusweb.boa.biddingstrategy.BiddingStrategy;
+import geniusweb.inform.Settings;
 import geniusweb.opponentmodel.OpponentModel;
-import geniusweb.party.inform.Settings;
 import tudelft.utilities.logging.Reporter;
 
Index: /boa/src/main/java/geniusweb/boa/BoaState.java
===================================================================
--- /boa/src/main/java/geniusweb/boa/BoaState.java	(revision 20)
+++ /boa/src/main/java/geniusweb/boa/BoaState.java	(revision 21)
@@ -12,7 +12,7 @@
 import geniusweb.boa.acceptancestrategy.AcceptanceStrategy;
 import geniusweb.boa.biddingstrategy.BiddingStrategy;
+import geniusweb.inform.Settings;
 import geniusweb.issuevalue.Bid;
 import geniusweb.opponentmodel.OpponentModel;
-import geniusweb.party.inform.Settings;
 import geniusweb.profile.Profile;
 import geniusweb.progress.Progress;
Index: /boa/src/main/java/geniusweb/boa/DefaultBoa.java
===================================================================
--- /boa/src/main/java/geniusweb/boa/DefaultBoa.java	(revision 20)
+++ /boa/src/main/java/geniusweb/boa/DefaultBoa.java	(revision 21)
@@ -11,13 +11,13 @@
 import geniusweb.boa.acceptancestrategy.AcceptanceStrategy;
 import geniusweb.boa.biddingstrategy.BiddingStrategy;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.opponentmodel.OpponentModel;
 import geniusweb.party.Capabilities;
 import geniusweb.party.DefaultParty;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profileconnection.ProfileConnectionFactory;
 import geniusweb.profileconnection.ProfileInterface;
Index: /boa/src/main/java/geniusweb/boa/acceptancestrategy/AcceptanceStrategy.java
===================================================================
--- /boa/src/main/java/geniusweb/boa/acceptancestrategy/AcceptanceStrategy.java	(revision 20)
+++ /boa/src/main/java/geniusweb/boa/acceptancestrategy/AcceptanceStrategy.java	(revision 21)
@@ -3,6 +3,6 @@
 import geniusweb.boa.BoaParty;
 import geniusweb.boa.BoaState;
+import geniusweb.inform.Settings;
 import geniusweb.issuevalue.Bid;
-import geniusweb.party.inform.Settings;
 
 /**
Index: /boa/src/main/java/geniusweb/boa/acceptancestrategy/TimeDependentAcceptanceStrategy.java
===================================================================
--- /boa/src/main/java/geniusweb/boa/acceptancestrategy/TimeDependentAcceptanceStrategy.java	(revision 20)
+++ /boa/src/main/java/geniusweb/boa/acceptancestrategy/TimeDependentAcceptanceStrategy.java	(revision 21)
@@ -6,6 +6,6 @@
 import geniusweb.boa.BoaState;
 import geniusweb.boa.biddingstrategy.TimeDependentBiddingStrategy;
+import geniusweb.inform.Settings;
 import geniusweb.issuevalue.Bid;
-import geniusweb.party.inform.Settings;
 import geniusweb.profile.Profile;
 import geniusweb.profile.utilityspace.LinearAdditive;
Index: /boa/src/main/java/geniusweb/boa/biddingstrategy/BiddingStrategy.java
===================================================================
--- /boa/src/main/java/geniusweb/boa/biddingstrategy/BiddingStrategy.java	(revision 20)
+++ /boa/src/main/java/geniusweb/boa/biddingstrategy/BiddingStrategy.java	(revision 21)
@@ -4,5 +4,5 @@
 import geniusweb.boa.BoaParty;
 import geniusweb.boa.BoaState;
-import geniusweb.party.inform.Settings;
+import geniusweb.inform.Settings;
 
 /**
Index: /boa/src/main/java/geniusweb/boa/biddingstrategy/TimeDependentBiddingStrategy.java
===================================================================
--- /boa/src/main/java/geniusweb/boa/biddingstrategy/TimeDependentBiddingStrategy.java	(revision 20)
+++ /boa/src/main/java/geniusweb/boa/biddingstrategy/TimeDependentBiddingStrategy.java	(revision 21)
@@ -13,6 +13,6 @@
 import geniusweb.actions.PartyId;
 import geniusweb.boa.BoaState;
+import geniusweb.inform.Settings;
 import geniusweb.issuevalue.Bid;
-import geniusweb.party.inform.Settings;
 import geniusweb.profile.Profile;
 import geniusweb.profile.utilityspace.LinearAdditive;
Index: /boa/src/test/java/geniusweb/boa/BoaPartyTest.java
===================================================================
--- /boa/src/test/java/geniusweb/boa/BoaPartyTest.java	(revision 20)
+++ /boa/src/test/java/geniusweb/boa/BoaPartyTest.java	(revision 21)
@@ -24,12 +24,12 @@
 import geniusweb.boa.biddingstrategy.BiddingStrategy;
 import geniusweb.connection.ConnectionEnd;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.issuevalue.DiscreteValue;
 import geniusweb.issuevalue.Domain;
 import geniusweb.opponentmodel.OpponentModel;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.progress.Progress;
 import geniusweb.references.Parameters;
Index: /boa/src/test/java/geniusweb/boa/acceptancestrategy/TimeDepAccStratTest.java
===================================================================
--- /boa/src/test/java/geniusweb/boa/acceptancestrategy/TimeDepAccStratTest.java	(revision 20)
+++ /boa/src/test/java/geniusweb/boa/acceptancestrategy/TimeDepAccStratTest.java	(revision 21)
@@ -16,6 +16,6 @@
 import geniusweb.bidspace.Interval;
 import geniusweb.boa.BoaState;
+import geniusweb.inform.Settings;
 import geniusweb.issuevalue.Bid;
-import geniusweb.party.inform.Settings;
 import geniusweb.profile.Profile;
 import geniusweb.profile.utilityspace.LinearAdditive;
@@ -46,4 +46,5 @@
 
 		TimeDependentAcceptanceStrategy ac = new TimeDependentAcceptanceStrategy() {
+			@Override
 			protected BidsWithUtility getBidspace(Profile profile) {
 				return testbidspace;
@@ -52,5 +53,5 @@
 		// we use default e=1, k=0 which means p(0)=1
 
-		when(progress.get(any())).thenReturn((Double) 0.0d);
+		when(progress.get(any())).thenReturn(0.0d);
 
 		when(linearprofile.getUtility(eq(bid1)))
@@ -67,4 +68,5 @@
 
 		TimeDependentAcceptanceStrategy ac = new TimeDependentAcceptanceStrategy() {
+			@Override
 			protected BidsWithUtility getBidspace(Profile profile) {
 				return testbidspace;
@@ -73,5 +75,5 @@
 		// we use default e=1, k=0 which means p(0)=1
 
-		when(progress.get(any())).thenReturn((Double) 0.0d);
+		when(progress.get(any())).thenReturn(0.0d);
 
 		when(linearprofile.getUtility(eq(bid1)))
@@ -87,4 +89,5 @@
 
 		TimeDependentAcceptanceStrategy ac = new TimeDependentAcceptanceStrategy() {
+			@Override
 			protected BidsWithUtility getBidspace(Profile profile) {
 				return testbidspace;
@@ -93,5 +96,5 @@
 		// we use default e=1, k=0 which means p(1)=0
 
-		when(progress.get(any())).thenReturn((Double) 1.0d);
+		when(progress.get(any())).thenReturn(1.0d);
 
 		when(linearprofile.getUtility(eq(bid1)))
@@ -110,4 +113,5 @@
 
 		TimeDependentAcceptanceStrategy ac = new TimeDependentAcceptanceStrategy() {
+			@Override
 			protected BidsWithUtility getBidspace(Profile profile) {
 				return testbidspace;
@@ -116,5 +120,5 @@
 		// we use default e=1, k=0 which means p(1)=resValue.
 
-		when(progress.get(any())).thenReturn((Double) 1.0d);
+		when(progress.get(any())).thenReturn(1.0d);
 
 		when(linearprofile.getUtility(eq(bid1)))
Index: /boa/src/test/java/geniusweb/boa/biddingstrategy/TimeDepBidStratTest.java
===================================================================
--- /boa/src/test/java/geniusweb/boa/biddingstrategy/TimeDepBidStratTest.java	(revision 20)
+++ /boa/src/test/java/geniusweb/boa/biddingstrategy/TimeDepBidStratTest.java	(revision 21)
@@ -17,7 +17,7 @@
 import geniusweb.actions.Offer;
 import geniusweb.boa.BoaState;
+import geniusweb.inform.Settings;
 import geniusweb.issuevalue.Bid;
 import geniusweb.issuevalue.DiscreteValue;
-import geniusweb.party.inform.Settings;
 import geniusweb.profile.utilityspace.LinearAdditive;
 import geniusweb.progress.Progress;
@@ -46,4 +46,5 @@
 
 		biddingstrat = new TimeDependentBiddingStrategy() {
+			@Override
 			protected ExtendedUtilSpace getBidSpace(LinearAdditive profile) {
 				return extUtilSpace;
Index: /collectparties.sh
===================================================================
--- /collectparties.sh	(revision 20)
+++ /collectparties.sh	(revision 21)
@@ -7,5 +7,5 @@
 rm -rf collectedparties
 mkdir collectedparties
-VERSION=1.4.4
+VERSION=1.5.0
 
 cp "exampleparties/anac2019/agentgg/target/agentgg-${VERSION}-jar-with-dependencies.jar" collectedparties
Index: /events/src/main/java/geniusweb/actions/Action.java
===================================================================
--- /events/src/main/java/geniusweb/actions/Action.java	(revision 20)
+++ /events/src/main/java/geniusweb/actions/Action.java	(revision 21)
@@ -16,5 +16,7 @@
 		@JsonSubTypes.Type(value = Accept.class),
 		@JsonSubTypes.Type(value = Comparison.class),
-		@JsonSubTypes.Type(value = ElicitComparison.class) })
+		@JsonSubTypes.Type(value = ElicitComparison.class),
+		@JsonSubTypes.Type(value = Vote.class),
+		@JsonSubTypes.Type(value = Votes.class) })
 public interface Action {
 	/**
Index: /events/src/main/java/geniusweb/actions/Vote.java
===================================================================
--- /events/src/main/java/geniusweb/actions/Vote.java	(revision 21)
+++ /events/src/main/java/geniusweb/actions/Vote.java	(revision 21)
@@ -0,0 +1,75 @@
+package geniusweb.actions;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+import com.fasterxml.jackson.annotation.JsonTypeName;
+
+import geniusweb.issuevalue.Bid;
+
+/**
+ * A vote is an indication by a party that it conditionally accepts a bid. It's
+ * then up to the protocol to determine the outcome.
+ */
+@JsonTypeName("vote")
+public class Vote extends ActionWithBid {
+	private final Integer minPower;
+
+	/**
+	 * @param id       the {@link PartyId} that does the action
+	 * @param bid      the bid that is voted on
+	 * @param minPower the minimum power this bid must get in order for the vote
+	 *                 to be valid. If power=1 for all participants (usually the
+	 *                 default) power can be interpreted as number of votes
+	 */
+	@JsonCreator
+	public Vote(@JsonProperty("actor") PartyId id, @JsonProperty("bid") Bid bid,
+			@JsonProperty("minPower") Integer minPower) {
+		super(id, bid);
+		this.minPower = minPower;
+		if (bid == null || minPower == null || minPower < 1) {
+			throw new IllegalArgumentException(
+					"Vote must have non-null bid and minVotes, and minVotes must be >=1");
+		}
+	}
+
+	/**
+	 * 
+	 * @return the minimum number of votes this bid must get in order for the
+	 *         vote to be valid.
+	 */
+	public Integer getMinPower() {
+		return minPower;
+	}
+
+	@Override
+	public String toString() {
+		return "Vote[" + getActor() + "," + getBid() + "," + minPower + "]";
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = super.hashCode();
+		result = prime * result
+				+ ((minPower == null) ? 0 : minPower.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (!super.equals(obj))
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		Vote other = (Vote) obj;
+		if (minPower == null) {
+			if (other.minPower != null)
+				return false;
+		} else if (!minPower.equals(other.minPower))
+			return false;
+		return true;
+	}
+
+}
Index: /events/src/main/java/geniusweb/actions/Votes.java
===================================================================
--- /events/src/main/java/geniusweb/actions/Votes.java	(revision 21)
+++ /events/src/main/java/geniusweb/actions/Votes.java	(revision 21)
@@ -0,0 +1,121 @@
+package geniusweb.actions;
+
+import java.util.Collections;
+import java.util.List;
+import java.util.Map;
+import java.util.Map.Entry;
+import java.util.Optional;
+import java.util.stream.Collectors;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+
+import geniusweb.issuevalue.Bid;
+
+/**
+ * Indicates that a party conditionally agrees with any of the {@link Vote}s
+ * provided.
+ */
+public class Votes extends AbstractAction {
+	private final List<Vote> votes;
+
+	/**
+	 * 
+	 * @param id    party id
+	 * @param votes the {@link Vote}s that the party can agree on, if the
+	 *              condition of the Vote holds. There can be at most 1
+	 *              {@link Vote} for each bid.
+	 */
+	@JsonCreator
+	public Votes(@JsonProperty("actor") PartyId id,
+			@JsonProperty("votes") List<Vote> votes) {
+		super(id);
+		this.votes = votes;
+		if (votes == null)
+			throw new NullPointerException("votes must be not null");
+		for (Vote vote : votes) {
+			if (!vote.getActor().equals(id)) {
+				throw new IllegalArgumentException("All votes must come from "
+						+ id + " but found " + vote);
+			}
+		}
+		Map<Bid, Long> counts = votes.stream().map(vote -> vote.getBid())
+				.collect(Collectors.groupingBy(bid -> bid,
+						Collectors.counting()));
+		Optional<Entry<Bid, Long>> nonunique = counts.entrySet().stream()
+				.filter(entry -> entry.getValue() > 1).findAny();
+		if (nonunique.isPresent())
+			throw new IllegalArgumentException(
+					"Votes contains multiple Vote's for "
+							+ nonunique.get().getKey());
+
+	}
+
+	/**
+	 * Test if Votes extends other votes. Extending means that for each vote on
+	 * bid B with power P in othervotes, this contains also a vote for bid B
+	 * with power at most P.
+	 * 
+	 * @param otherVotes
+	 * @return true iff this extends the otherVotes.
+	 */
+	public boolean isExtending(Votes otherVotes) {
+		if (!otherVotes.getActor().equals(getActor()))
+			return false;
+		for (Vote vote : otherVotes.getVotes()) {
+			Vote myvote = getVote(vote.getBid());
+			if (myvote == null)
+				return false;
+			if (myvote.getMinPower() > vote.getMinPower())
+				return false;
+		}
+		return true;
+	}
+
+	/**
+	 * 
+	 * @param bid the bid that we may have a vote for
+	 * @return myvote for bid, or null if no vote for that bid;
+	 */
+	public Vote getVote(Bid bid) {
+		for (Vote vote : votes) {
+			if (vote.getBid().equals(bid))
+				return vote;
+		}
+		return null;
+	}
+
+	public List<Vote> getVotes() {
+		return Collections.unmodifiableList(votes);
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = super.hashCode();
+		result = prime * result + ((votes == null) ? 0 : votes.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (!super.equals(obj))
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		Votes other = (Votes) obj;
+		if (votes == null) {
+			if (other.votes != null)
+				return false;
+		} else if (!votes.equals(other.votes))
+			return false;
+		return true;
+	}
+
+	@Override
+	public String toString() {
+		return "Votes[" + getActor() + "," + votes + "]";
+	}
+}
Index: /events/src/main/java/geniusweb/inform/ActionDone.java
===================================================================
--- /events/src/main/java/geniusweb/inform/ActionDone.java	(revision 21)
+++ /events/src/main/java/geniusweb/inform/ActionDone.java	(revision 21)
@@ -0,0 +1,53 @@
+package geniusweb.inform;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+
+import geniusweb.actions.Action;
+
+/**
+ * Informs that someone did an action
+ */
+public class ActionDone implements Inform {
+
+	private final Action action;
+
+	@JsonCreator
+	public ActionDone(@JsonProperty("action") Action action) {
+		this.action = action;
+	}
+
+	public Action getAction() {
+		return action;
+	}
+
+	@Override
+	public String toString() {
+		return "ActionDone[" + action + "]";
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result + ((action == null) ? 0 : action.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		ActionDone other = (ActionDone) obj;
+		if (action == null) {
+			if (other.action != null)
+				return false;
+		} else if (!action.equals(other.action))
+			return false;
+		return true;
+	}
+}
Index: /events/src/main/java/geniusweb/inform/Agreements.java
===================================================================
--- /events/src/main/java/geniusweb/inform/Agreements.java	(revision 21)
+++ /events/src/main/java/geniusweb/inform/Agreements.java	(revision 21)
@@ -0,0 +1,111 @@
+package geniusweb.inform;
+
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.Map;
+import java.util.Set;
+
+import com.fasterxml.jackson.annotation.JsonAutoDetect;
+import com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility;
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonValue;
+
+import geniusweb.actions.PartyId;
+import geniusweb.issuevalue.Bid;
+
+/**
+ * There can be multiple agreements from a single negotiation. This object
+ * contains the agreements. Each party can agree only on 1 bid and there are
+ * always at least 2 parties agreeing on a bid.
+ */
+@JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE)
+public class Agreements {
+	@JsonValue
+	private final Map<PartyId, Bid> agreements;
+
+	public Agreements() {
+		this.agreements = Collections.emptyMap();
+	}
+
+	@JsonCreator
+	private Agreements(Map<PartyId, Bid> agrees) {
+		this.agreements = agrees;
+	}
+
+	/**
+	 * @param other {@link Agreements}
+	 * @return a new Agreement containing this plus other agreements
+	 * @throws IllegalArgumentException if parties in other are already in this
+	 *                                  agreement.
+	 */
+	public Agreements with(Agreements other) {
+		Map<PartyId, Bid> newagrees = new HashMap<>(agreements);
+		for (PartyId pid : other.agreements.keySet()) {
+			if (newagrees.containsKey(pid))
+				throw new IllegalArgumentException(
+						"party " + pid + " already has agreement");
+			newagrees.put(pid, other.agreements.get(pid));
+		}
+		return new Agreements(newagrees);
+	}
+
+	/**
+	 * @param bid
+	 * @param parties
+	 * @return new Agreements, with the new bid/parties added.
+	 */
+	public Agreements with(Bid bid, Set<PartyId> parties) {
+		if (parties.size() < 2) {
+			throw new IllegalArgumentException(
+					"Agreement must contain at least 2 parties");
+		}
+		Map<PartyId, Bid> newagreements = new HashMap<>(agreements);
+		for (PartyId party : parties) {
+			if (agreements.containsKey(party)) {
+				throw new IllegalArgumentException(
+						"A party can agree only on 1 bid");
+			}
+			newagreements.put(party, bid);
+		}
+		return new Agreements(newagreements);
+	}
+
+	/**
+	 * @return actual agreemenets contained here
+	 */
+	public Map<PartyId, Bid> getMap() {
+		return Collections.unmodifiableMap(agreements);
+	}
+
+	@Override
+	public String toString() {
+		return "Agreements" + agreements;
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result
+				+ ((agreements == null) ? 0 : agreements.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		Agreements other = (Agreements) obj;
+		if (agreements == null) {
+			if (other.agreements != null)
+				return false;
+		} else if (!agreements.equals(other.agreements))
+			return false;
+		return true;
+	}
+
+}
Index: /events/src/main/java/geniusweb/inform/Finished.java
===================================================================
--- /events/src/main/java/geniusweb/inform/Finished.java	(revision 21)
+++ /events/src/main/java/geniusweb/inform/Finished.java	(revision 21)
@@ -0,0 +1,59 @@
+package geniusweb.inform;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+
+/**
+ * Informs that the session is finished, and also contains the bid that was
+ * agreed on.
+ *
+ */
+public class Finished implements Inform {
+	private final Agreements agreements;
+
+	/**
+	 * The session finished (can be for any reason).
+	 * 
+	 * @param agreedBid the bid that was finally agreed on; null if no
+	 *                  agreement.
+	 */
+	@JsonCreator
+	public Finished(@JsonProperty("agreements") Agreements agreements) {
+		this.agreements = agreements;
+	}
+
+	public Agreements getAgreement() {
+		return agreements;
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result
+				+ ((agreements == null) ? 0 : agreements.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		Finished other = (Finished) obj;
+		if (agreements == null) {
+			if (other.agreements != null)
+				return false;
+		} else if (!agreements.equals(other.agreements))
+			return false;
+		return true;
+	}
+
+	@Override
+	public String toString() {
+		return "Finished[" + agreements + "]";
+	}
+}
Index: /events/src/main/java/geniusweb/inform/Inform.java
===================================================================
--- /events/src/main/java/geniusweb/inform/Inform.java	(revision 21)
+++ /events/src/main/java/geniusweb/inform/Inform.java	(revision 21)
@@ -0,0 +1,22 @@
+package geniusweb.inform;
+
+import com.fasterxml.jackson.annotation.JsonAutoDetect;
+import com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility;
+import com.fasterxml.jackson.annotation.JsonSubTypes;
+import com.fasterxml.jackson.annotation.JsonTypeInfo;
+
+/**
+ * base class of all information sent to the {@link Party}
+ */
+@JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.WRAPPER_OBJECT)
+@JsonSubTypes({ @JsonSubTypes.Type(value = ActionDone.class),
+		@JsonSubTypes.Type(value = Inform.class),
+		@JsonSubTypes.Type(value = Settings.class),
+		@JsonSubTypes.Type(value = Finished.class),
+		@JsonSubTypes.Type(value = YourTurn.class),
+		@JsonSubTypes.Type(value = Voting.class),
+		@JsonSubTypes.Type(value = OptIn.class) })
+@JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE)
+public interface Inform {
+
+}
Index: /events/src/main/java/geniusweb/inform/OptIn.java
===================================================================
--- /events/src/main/java/geniusweb/inform/OptIn.java	(revision 21)
+++ /events/src/main/java/geniusweb/inform/OptIn.java	(revision 21)
@@ -0,0 +1,79 @@
+package geniusweb.inform;
+
+import java.util.Collections;
+import java.util.List;
+import java.util.Map;
+import java.util.Map.Entry;
+import java.util.Optional;
+import java.util.stream.Collectors;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+
+import geniusweb.actions.PartyId;
+import geniusweb.actions.Votes;
+
+/**
+ * Informs party that it's time to Opt-in.
+ */
+public class OptIn implements Inform {
+
+	private final List<Votes> votes;
+
+	/**
+	 * @param votes a list of votes. There may be only one votes per party.
+	 */
+	@JsonCreator
+	public OptIn(@JsonProperty("votes") List<Votes> votes) {
+		this.votes = votes;
+
+		Map<PartyId, Long> counts = votes.stream().map(vote -> vote.getActor())
+				.collect(Collectors.groupingBy(actor -> actor,
+						Collectors.counting()));
+		Optional<Entry<PartyId, Long>> nonunique = counts.entrySet().stream()
+				.filter(entry -> entry.getValue() > 1).findAny();
+		if (nonunique.isPresent())
+			throw new IllegalArgumentException(
+					"OptIn contains multiple Votes for party "
+							+ nonunique.get().getKey());
+
+	}
+
+	/**
+	 * @return list of votes that can be opted in to
+	 */
+	public List<Votes> getVotes() {
+		return Collections.unmodifiableList(votes);
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result + ((votes == null) ? 0 : votes.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		OptIn other = (OptIn) obj;
+		if (votes == null) {
+			if (other.votes != null)
+				return false;
+		} else if (!votes.equals(other.votes))
+			return false;
+		return true;
+	}
+
+	@Override
+	public String toString() {
+		return "OptIn[" + votes + "]";
+	}
+
+}
Index: /events/src/main/java/geniusweb/inform/Settings.java
===================================================================
--- /events/src/main/java/geniusweb/inform/Settings.java	(revision 21)
+++ /events/src/main/java/geniusweb/inform/Settings.java	(revision 21)
@@ -0,0 +1,152 @@
+package geniusweb.inform;
+
+import java.util.HashMap;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+
+import geniusweb.actions.PartyId;
+import geniusweb.progress.Progress;
+import geniusweb.references.Parameters;
+import geniusweb.references.ProfileRef;
+import geniusweb.references.ProtocolRef;
+
+/**
+ * Informs a {@link Party} about all settings for the upcoming negotiation
+ * session. This should be sent to a party one time, so that the party knows the
+ * situation.
+ *
+ */
+public class Settings implements Inform {
+	private ProfileRef profile;
+	private ProtocolRef protocol;
+	private Progress progress;
+	private PartyId id;
+	private Parameters parameters;
+
+	/**
+	 * 
+	 * @param id         the {@link PartyId} for this party
+	 * @param profile    the profile used for this party in this session
+	 * @param protocol   the protocol used in this session
+	 * @param progress   the {@link Progress} object used for this session
+	 * @param parameters a Map<String, Object> containing initialization
+	 *                   parameters for this party. The Object can be a HashMap,
+	 *                   ArrayList, String, or number (Integer, Double, etc).
+	 *                   The Object should not be just any Object because
+	 *                   deserialization will work only with the mentioned
+	 *                   types.
+	 */
+	@JsonCreator
+	public Settings(@JsonProperty("id") PartyId id,
+			@JsonProperty("profile") ProfileRef profile,
+			@JsonProperty("protocol") ProtocolRef protocol,
+			@JsonProperty("progress") Progress progress,
+			@JsonProperty("parameters") Parameters parameters) {
+		if (profile == null || protocol == null || progress == null
+				|| parameters == null) {
+			throw new IllegalArgumentException(
+					"party, profile, protocol, parameters and progress must be not null.");
+		}
+		this.profile = profile;
+		this.protocol = protocol;
+		this.progress = progress;
+		this.parameters = parameters;
+		this.id = id;
+	}
+
+	/**
+	 * 
+	 * @return the profile used for this party in this session
+	 */
+	public ProfileRef getProfile() {
+		return profile;
+	}
+
+	public ProtocolRef getProtocol() {
+		return protocol;
+	}
+
+	/**
+	 * 
+	 * @return the {@link Progress} object used for this session
+	 */
+	public Progress getProgress() {
+		return progress;
+	}
+
+	/**
+	 * @return the party ID of this party
+	 */
+	public PartyId getID() {
+		return id;
+	}
+
+	/**
+	 * 
+	 * @return a HashMap<String,Object> containing initialization parameters
+	 *         that can be used by the party.
+	 */
+	public HashMap<String, Object> getParameters() {
+		return parameters;
+	}
+
+	@Override
+	public String toString() {
+		return "Settings[" + id + "," + profile + "," + protocol + ","
+				+ progress + "," + parameters + "]";
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result + ((id == null) ? 0 : id.hashCode());
+		result = prime * result
+				+ ((parameters == null) ? 0 : parameters.hashCode());
+		result = prime * result + ((profile == null) ? 0 : profile.hashCode());
+		result = prime * result
+				+ ((progress == null) ? 0 : progress.hashCode());
+		result = prime * result
+				+ ((protocol == null) ? 0 : protocol.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		Settings other = (Settings) obj;
+		if (id == null) {
+			if (other.id != null)
+				return false;
+		} else if (!id.equals(other.id))
+			return false;
+		if (parameters == null) {
+			if (other.parameters != null)
+				return false;
+		} else if (!parameters.equals(other.parameters))
+			return false;
+		if (profile == null) {
+			if (other.profile != null)
+				return false;
+		} else if (!profile.equals(other.profile))
+			return false;
+		if (progress == null) {
+			if (other.progress != null)
+				return false;
+		} else if (!progress.equals(other.progress))
+			return false;
+		if (protocol == null) {
+			if (other.protocol != null)
+				return false;
+		} else if (!protocol.equals(other.protocol))
+			return false;
+		return true;
+	}
+
+}
